/* slurp-example-application.c
 *
 * Copyright (C) 2017 Julian Richen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>

#include <slurp/slurp.h>
#include <slurp-gtk/slurp-gtk.h>

static void
activate (GtkApplication *application,
          gpointer        user_data)
{
    GtkWidget *window;
    GtkWidget *headerbar;
    SlurpDownload *slurp;
    SlurpWidget *slurp_widget;

    window = gtk_application_window_new (application);
    gtk_window_set_title (GTK_WINDOW (window), "Slurp Example");
    gtk_window_set_default_size (GTK_WINDOW (window), 320, 480);

    headerbar = gtk_header_bar_new ();
    gtk_header_bar_set_show_close_button (GTK_HEADER_BAR (headerbar), TRUE);
    gtk_header_bar_set_title (GTK_HEADER_BAR (headerbar), "Slurp Example");
    gtk_window_set_titlebar (GTK_WINDOW (window), headerbar);

    slurp = slurp_download_new ();
    slurp_widget = slurp_widget_new ();
    //gtk_container_add (GTK_CONTAINER (button_box), button);

    gtk_widget_show_all (window);
}

int
main (int    argc,
      char **argv)
{
    GtkApplication *application;
    int status;

    application = gtk_application_new ("org.gnome.slurp.application",
                                       G_APPLICATION_FLAGS_NONE);

    g_signal_connect (application, "activate", G_CALLBACK (activate), NULL);

    status = g_application_run (G_APPLICATION (application), argc, argv);

    g_object_unref (application);

    return status;
}
