/* slurp-download.h
 *
 * Copyright (C) 2017 Julian Richen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SLURP_DOWNLOAD_H
#define SLURP_DOWNLOAD_H

#include <glib-object.h>

#include <glib.h>
#include <gio/gio.h>
#include <libsoup/soup.h>

G_BEGIN_DECLS

#define SLURP_TYPE_DOWNLOAD (slurp_download_get_type())

G_DECLARE_FINAL_TYPE (SlurpDownload, slurp_download, SLURP, DOWNLOAD, GObject)

typedef void (* DownloadResourceDataProgress) (guint64   downloaded_bytes,
                                               guint64   total_bytes,
                                               gpointer  user_data);

typedef void (* DownloadResourceDataCallback) (gpointer user_data);

SlurpDownload *
slurp_download_new (void);

void
slurp_download_add_uri_full (SlurpDownload                *self,
                             gchar                        *uri,
                             gchar                        *path,
                             gboolean                      overwrite,
                             GCancellable                 *cancellable,
                             DownloadResourceDataProgress  p_handler,
                             gpointer                      p_user_data,
                             DownloadResourceDataCallback  c_handler,
                             gpointer                      c_user_data);

void
slurp_download_add_uri_with_path (SlurpDownload *self,
                                  gchar         *uri,
                                  gchar         *path,
                                  GCancellable  *cancellable);

void
slurp_download_add_uri (SlurpDownload *self,
                        gchar         *uri,
                        GCancellable  *cancellable);

G_END_DECLS

#endif /* SLURP_DOWNLOAD_H */

